<?= $element->renderSubmenu('/7-lekce-zpracovani-formulare'); ?>

<h1 class="mainTitle"><?= $template->title; ?></h1>

<p>
	Jak jsme si řekli, jedinou možností jak komunikovat skrze web s PHP je pomocí formulářů.<br>
	Na webu máme formulář. Ten vyplníme a pomocí odesílacího tlačítka jej odešleme.
	Vyplněná data z formuláře se odešlou na URL, která je uvedena v atributu <b>action</b> v tagu <b>form</b>.
	Jakým způsobem se data odešlou (skrytě - <b>POST</b> nebo veřejně - <b>GET</b>) potom uvádíme v atributu <b>method</b> v tagu <b>form</b>.
</p>

<p><b>Ukázka:</b></p>
<pre class="php">
<span class="php__syntax">&lt;form</span> <span class="php__obj">method</span>=<span class="php__str">"post"</span> <span class="php__obj">action</span>=<span class="php__str">"zpracovaniFormulare.php"</span>>
    <span class="php__comment">&lt;!-- formulářové prvky --></span>
<span class="php__syntax">&lt;/form></span>
</pre>

<p>Data z formuláře výše se tedy odešlou skrytě (<b>POST</b>) na adresu <b>zpracovaniFormulare.php</b>. V tomto souboru pak můžeme tyto data získat a pracovat s nimi.</p>

<h2 class="mainTitle" id="get-a-post">Získání dat - GET a POST</h2>

<p>
	Řekli jsme si, že data se odesílají pomocí 2 možností - <b>GET</b> a <b>POST</b>. Práce s nimi je úplně stejná.
	Jediný rozdíl je v tom, že když data odešleme pomocí metody <b>POST</b> tak je neuvidíme - přenesou se v hlavičce <a href="https://www.zdrojak.cz/clanky/protokol-http/" target="_blank">požadavku</a>.
	Pokud použijeme metodu (která je mimochodem výchozí) <b>GET</b>, všechny data z formuláře se odešlou v URL adrese. Každý je uvidí.
</p>

<p>A pokud se například přihlašujeme do našeho e-mailu, asi bychom nechtěli aby se naše heslo ukazovalo v URL adrese. Proto se 99% formulářů odesílá pomocí metody <b>POST</b>.</p>

<p>V našem souboru <b>zpracovaniFormulare.php</b> bychom data z odeslaného formuláře získali následujícím způsobem:</p>

<pre class="php">
&lt;?php
    <span class="php__comment">// metoda POST</span>
    <span class="php__var">$data</span> = <span class="php__obj">$_POST</span>;

    <span class="php__comment">// metoda GET</span>
    <span class="php__var">$data</span> = <span class="php__obj">$_GET</span>;
?&gt;
</pre>

<p>
	Jak vidíme získání dat je velmi jednoduché.
	Obě serverové proměnné vrací pole. Pole má tolik prvků, kolik bylo odeslaných dat.
	Klíč prvku je atribut <b><span class="text-pink-dark">name</span> formulářového prvku</b> a hodnota je to co jsme napsali/zvolili ve formuláři.
</p>

<h2 class="mainTitle" id="bezpecnost">Bezpečnost</h2>

<p>
	V dnešním světě jsou data nejcenější komoditou. Ve většině případů webové stránky využívají databáze. Na stránkách pak můžete mít přihlašovací formulář, který ověří oproti databázi, zda se jedná o tohoto konkrétního uživatele, aby mu zobrazil nějaký obsah.
	A protože jsou data to nejcenější, existuje spousta lidí, kteří je chtějí ukrást. A data Vám mohou ukrást přes formulář. Proto je důležité veškerá formulářová data ošetřit proti útoku.
	Nejjednoduší způsob je pomocí PHP funkce <a href="https://www.php.net/manual/en/function.filter-input-array.php" target="_blank">filter_input_array</a>. Pomocí této funkce, lze ale ošetřit i <a href="https://www.php.net/manual/en/ref.filter.php" target="_blank">proměnné</a>.
</p>

<pre class="php">
&lt;?php
    <span class="php__var">$osetrenaData</span> = <span class="php__fun">filter_input_array</span>(<span class="php__num">INPUT_POST</span>, <span class="php__num">FILTER_SANITIZE_SPECIAL_CHARS</span>)

    <span class="php__var">$osetrenyJedenFormularovyPrvek</span> = <span class="php__fun">filter_input</span>(<span class="php__num">INPUT_POST</span>, <span class="php__str">'nazevPrvku'</span>, <span class="php__num">FILTER_SANITIZE_SPECIAL_CHARS</span>);
?&gt;
</pre>

<p>
	Když se na to podíváme tak v prvním případě ošetřujeme celou serverou proměnnou <b>POST</b> (pro GET by to bylo INPUT_GET - více v <a href="https://www.php.net/manual/en/filter.constants.php" target="_blank">dokumentaci</a>). Poté následuje <a href="https://www.php.net/manual/en/filter.filters.sanitize.php" target="_blank">konstanta</a> jazyka PHP pro ošetření speciálních znaků.
	A nyní máme v proměnné <b>$osetrenaData</b> ošetřená data a útočník už nám data "neukradne".
</p>

<p>
	Ve druhém případě je situace podobná. Nyní ale ošetřujeme pouze konkrétní prvek z formuláře. Jako první uvedeme metodu, kterou jsme si data nechali poslat (GET, POST).
	Poté následuje jméno prvku (atribut name). A jako třetí způsob jakým budeme data ošetřovat.
</p>

<p>PS: stále je spousta způsobů jak data ukrást, ale udělali jsme první a nejdůležitější krok.</p>

<h2 class="mainTitle" id="presmerovani">Přesměrování</h2>

<p>Pokud formulář zpracováváme v jiném souboru, než je samotný HTML formulář, bylo by vhodné uživatele přesměrovat zpět na formulář nebo na děkovnou stránku. To uděláme takto:</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">header</span>(<span class="php__str">"Location: http://www.example.com/"</span>);
    <span class="php__syntax">exit</span>();
?&gt;
</pre>

<p>
	Zavoláme funkci <b>header</b>, ve které jako parametr předáme řětězec. Řetězec začíná slovíčkem <b>Location:</b> s dvojtečkou. Poté následuje mezera a za ní URL adresa, kam chceme přesměrovat.
	Důležité je že, URL adresa musí být včetně <b>domény</b>. Ihned za přesměrováním napíšeme příkaz <b>exit();</b>. Toto vyplývá z <a href="https://www.php.net/manual/en/function.header.php" target="_blank">dokumentace</a> a best practice PHP.
</p>

<p>Také je potřeba říci. Že funkci <b>header</b> můžeme použít pouze tehdy, pokud jsme před tím nepoužili příkaz <b>echo</b> nebo <b>print_r</b> (neposlali jsme nic na výstup).</p>